/*
  Rainbow claps / 11 claps LED blink

  When button is pressed on the board, blink and stuff with rainnow clips rhythm.

  created 23 Mar 2022
  by Heng Chang

  */  

#include <SoftwareSerial.h>

SoftwareSerial mySerial(PA1,PA0);

const int button = 2;   // pin PA2 on ATtiny44a
const int led = 3;      // pin PA3 on ATtiny44a

/*
 Here comes the variables of rhythm
 */
int bpm = 60;                 // 60 meters/mins
int meter = (60/bpm)*1000;    // 1000 = 1s; If bpm higher, meter shorter
int half_meter = meter/2;    

int buttonData = 0;

void setup() {
  // initialize digital pin "led" as an output:
  pinMode(led, OUTPUT);
  // initialize digital pin "button" as an input:
  pinMode(button, INPUT);

  mySerial.begin(9600);
}

/*
 Run rainbow claps while LED is pressed
 */

void loop() {
  buttonData = digitalRead(button);   // variable for button push checking  
  if(buttonData == LOW)                //check the ButtonData is HIGH (HIGH means button is pressed)
      {
        mySerial.println("pressed");
          one_meter();
          one_meter();
          
          one_half_meter();   
          one_half_meter();  
          one_meter();    
          
          one_half_meter();   
          one_half_meter(); 
          one_half_meter();   
          one_half_meter();
          half_meter_rest();
          
          one_half_meter(); 
          one_meter();          
      }
}

/*
 One meter translate to LED flashing
 */

void one_meter(){
  digitalWrite(led,HIGH);            //Turn on LED
  delay(meter/2);
  digitalWrite(led,LOW);             //Turn off LED
  delay(meter/2);
}

/*
 One half meter translate to LED flashing
 */
void one_half_meter(){
  digitalWrite(led,HIGH);            //Turn on LED
  delay(half_meter/2);
  digitalWrite(led,LOW);             //Turn off LED
  delay(half_meter/2);
}

/*
Half meter rest translate to LED flashing
 */
void half_meter_rest(){
  digitalWrite(led,LOW);             //Turn off LED
  delay(half_meter/2);
}
